Index: uspace/lib/ui/src/pbutton.c
===================================================================
--- uspace/lib/ui/src/pbutton.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/pbutton.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -32,4 +32,7 @@
 /**
  * @file Push button
+ *
+ * Push button either uses text as decoration, or it can use a caller-provided
+ * function to paint the decoration.
  */
 
@@ -51,5 +54,7 @@
 enum {
 	ui_pb_press_dx = 1,
-	ui_pb_press_dy = 1
+	ui_pb_press_dy = 1,
+	ui_pb_pad_x = 2,
+	ui_pb_pad_x_text = 1
 };
 
@@ -111,4 +116,5 @@
 
 	ui_control_delete(pbutton->control);
+	free(pbutton->caption);
 	free(pbutton);
 }
@@ -136,4 +142,27 @@
 }
 
+/** Set push button decoration ops.
+ *
+ * @param pbutton Push button
+ * @param ops Push button decoration callbacks
+ * @param arg Decoration ops argument
+ */
+void ui_pbutton_set_decor_ops(ui_pbutton_t *pbutton,
+    ui_pbutton_decor_ops_t *ops, void *arg)
+{
+	pbutton->decor_ops = ops;
+	pbutton->decor_arg = arg;
+}
+
+/** Set push button flag.s
+ *
+ * @param pbutton Push button
+ * @param flags Flags
+ */
+void ui_pbutton_set_flags(ui_pbutton_t *pbutton, ui_pbutton_flags_t flags)
+{
+	pbutton->flags = flags;
+}
+
 /** Set button rectangle.
  *
@@ -157,4 +186,43 @@
 {
 	pbutton->isdefault = isdefault;
+}
+
+/** Get button light status.
+ *
+ * @param pbutton Button
+ * @return @c true iff light is on
+ */
+bool ui_pbutton_get_light(ui_pbutton_t *pbutton)
+{
+	return pbutton->light;
+}
+
+/** Turn button light on or off.
+ *
+ * @param pbutton Button
+ * @param light @c true iff button should be lit
+ */
+void ui_pbutton_set_light(ui_pbutton_t *pbutton, bool light)
+{
+	pbutton->light = light;
+}
+
+/** Set push button caption.
+ *
+ * @param pbutton Button
+ * @param caption New caption
+ * @return EOK on success, ENOMEM if out of memory
+ */
+errno_t ui_pbutton_set_caption(ui_pbutton_t *pbutton, const char *caption)
+{
+	char *dcaption;
+
+	dcaption = str_dup(caption);
+	if (dcaption == NULL)
+		return ENOMEM;
+
+	free(pbutton->caption);
+	pbutton->caption = dcaption;
+	return EOK;
 }
 
@@ -277,5 +345,7 @@
 	gfx_text_fmt_t fmt;
 	gfx_rect_t rect;
+	gfx_rect_t irect;
 	gfx_coord_t thickness;
+	gfx_color_t *color;
 	bool depressed;
 	errno_t rc;
@@ -289,5 +359,8 @@
 	rect.p1.y = pbutton->rect.p1.y - thickness;
 
-	rc = gfx_set_color(pbutton->res->gc, pbutton->res->btn_face_color);
+	color = pbutton->light ? pbutton->res->btn_face_lit_color :
+	    pbutton->res->btn_face_color;
+
+	rc = gfx_set_color(pbutton->res->gc, color);
 	if (rc != EOK)
 		goto error;
@@ -306,12 +379,25 @@
 	}
 
-	gfx_text_fmt_init(&fmt);
-	fmt.color = pbutton->res->btn_text_color;
-	fmt.halign = gfx_halign_center;
-	fmt.valign = gfx_valign_center;
-
-	rc = gfx_puttext(pbutton->res->font, &pos, &fmt, pbutton->caption);
-	if (rc != EOK)
-		goto error;
+	if (pbutton->decor_ops != NULL && pbutton->decor_ops->paint != NULL) {
+		/* Custom decoration */
+		rc = pbutton->decor_ops->paint(pbutton, pbutton->decor_arg,
+		    &pos);
+		if (rc != EOK)
+			goto error;
+	} else {
+		/* Text decoration */
+		ui_paint_get_inset_frame_inside(pbutton->res, &rect, &irect);
+		gfx_text_fmt_init(&fmt);
+		fmt.font = pbutton->res->font;
+		fmt.color = pbutton->res->btn_text_color;
+		fmt.halign = gfx_halign_center;
+		fmt.valign = gfx_valign_center;
+		fmt.abbreviate = true;
+		fmt.width = irect.p1.x - irect.p0.x - 2 * ui_pb_pad_x;
+
+		rc = gfx_puttext(&pos, &fmt, pbutton->caption);
+		if (rc != EOK)
+			goto error;
+	}
 
 	rc = ui_pbutton_paint_frame(pbutton);
@@ -351,5 +437,8 @@
 	errno_t rc;
 
-	depressed = pbutton->held && pbutton->inside;
+	if ((pbutton->flags & ui_pbf_no_text_depress) == 0)
+		depressed = pbutton->held && pbutton->inside;
+	else
+		depressed = false;
 
 	rc = gfx_set_color(pbutton->res->gc, pbutton->res->wnd_face_color);
@@ -379,9 +468,14 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = pbutton->res->font;
 	fmt.color = pbutton->res->btn_text_color;
 	fmt.halign = gfx_halign_center;
 	fmt.valign = gfx_valign_center;
-
-	rc = gfx_puttext(pbutton->res->font, &pos, &fmt, pbutton->caption);
+	fmt.abbreviate = true;
+	fmt.width = rect.p1.x - rect.p0.x - 2 * ui_pb_pad_x_text;
+	if (fmt.width < 1)
+		fmt.width = 1;
+
+	rc = gfx_puttext(&pos, &fmt, pbutton->caption);
 	if (rc != EOK)
 		goto error;
@@ -427,4 +521,5 @@
 	pbutton->held = true;
 	(void) ui_pbutton_paint(pbutton);
+	ui_pbutton_down(pbutton);
 }
 
@@ -439,4 +534,5 @@
 
 	pbutton->held = false;
+	ui_pbutton_up(pbutton);
 
 	if (pbutton->inside) {
@@ -474,5 +570,5 @@
 }
 
-/** Button was clicked.
+/** Send button clicked event.
  *
  * @param pbutton Push button
@@ -482,4 +578,24 @@
 	if (pbutton->cb != NULL && pbutton->cb->clicked != NULL)
 		pbutton->cb->clicked(pbutton, pbutton->arg);
+}
+
+/** Send button down event.
+ *
+ * @param pbutton Push button
+ */
+void ui_pbutton_down(ui_pbutton_t *pbutton)
+{
+	if (pbutton->cb != NULL && pbutton->cb->down != NULL)
+		pbutton->cb->down(pbutton, pbutton->arg);
+}
+
+/** Send button up event.
+ *
+ * @param pbutton Push button
+ */
+void ui_pbutton_up(ui_pbutton_t *pbutton)
+{
+	if (pbutton->cb != NULL && pbutton->cb->up != NULL)
+		pbutton->cb->up(pbutton, pbutton->arg);
 }
 
@@ -521,4 +637,6 @@
 		}
 		break;
+	case POS_DCLICK:
+		break;
 	}
 
Index: uspace/lib/ui/src/popup.c
===================================================================
--- uspace/lib/ui/src/popup.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/popup.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -36,5 +36,5 @@
 #include <errno.h>
 #include <gfx/context.h>
-//#include <io/kbd_event.h>
+#include <io/kbd_event.h>
 #include <io/pos_event.h>
 #include <mem.h>
@@ -47,8 +47,10 @@
 
 static void ui_popup_window_close(ui_window_t *, void *);
+static void ui_popup_window_kbd(ui_window_t *, void *, kbd_event_t *);
 static void ui_popup_window_pos(ui_window_t *, void *, pos_event_t *);
 
 static ui_window_cb_t ui_popup_window_cb = {
 	.close = ui_popup_window_close,
+	.kbd = ui_popup_window_kbd,
 	.pos = ui_popup_window_pos
 };
@@ -96,5 +98,6 @@
 	wparams.style &= ~ui_wds_decorated;
 	wparams.placement = ui_wnd_place_popup;
-	wparams.flags |= ui_wndf_popup;
+	wparams.flags |= ui_wndf_popup | ui_wndf_topmost;
+	wparams.idev_id = params->idev_id;
 
 	/* Compute position of parent rectangle relative to the screen */
@@ -187,4 +190,14 @@
 }
 
+/** Get ID of device that sent the last position event.
+ *
+ * @param popup Popup window
+ * @return Input device ID
+ */
+sysarg_t ui_popup_get_idev_id(ui_popup_t *popup)
+{
+	return popup->idev_id;
+}
+
 /** Handle close event in popup window.
  *
@@ -200,4 +213,22 @@
 }
 
+/** Handle keyboard event in popup window.
+ *
+ * @param window Window
+ * @param arg Argument (ui_popup_t *)
+ * @param event Keyboard event
+ */
+static void ui_popup_window_kbd(ui_window_t *window, void *arg,
+    kbd_event_t *event)
+{
+	ui_popup_t *popup = (ui_popup_t *)arg;
+
+	/* Remember ID of device that sent the last event */
+	popup->idev_id = event->kbd_id;
+
+	if (popup->cb != NULL && popup->cb->kbd != NULL)
+		popup->cb->kbd(popup, popup->arg, event);
+}
+
 /** Handle position event in popup window.
  *
@@ -211,4 +242,7 @@
 	ui_popup_t *popup = (ui_popup_t *)arg;
 
+	/* Remember ID of device that sent the last event */
+	popup->idev_id = event->pos_id;
+
 	if (popup->cb != NULL && popup->cb->pos != NULL)
 		popup->cb->pos(popup, popup->arg, event);
Index: uspace/lib/ui/src/promptdialog.c
===================================================================
--- uspace/lib/ui/src/promptdialog.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/promptdialog.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -327,5 +327,5 @@
 {
 	ui_prompt_dialog_t *dialog = (ui_prompt_dialog_t *) arg;
-	const char *fname;
+	const char *text;
 
 	if (event->type == KEY_PRESS &&
@@ -334,6 +334,6 @@
 			/* Confirm */
 			if (dialog->cb != NULL && dialog->cb->bok != NULL) {
-				fname = ui_entry_get_text(dialog->ename);
-				dialog->cb->bok(dialog, dialog->arg, fname);
+				text = ui_entry_get_text(dialog->ename);
+				dialog->cb->bok(dialog, dialog->arg, text);
 				return;
 			}
@@ -358,9 +358,9 @@
 {
 	ui_prompt_dialog_t *dialog = (ui_prompt_dialog_t *) arg;
-	const char *fname;
+	const char *text;
 
 	if (dialog->cb != NULL && dialog->cb->bok != NULL) {
-		fname = ui_entry_get_text(dialog->ename);
-		dialog->cb->bok(dialog, dialog->arg, fname);
+		text = ui_entry_get_text(dialog->ename);
+		dialog->cb->bok(dialog, dialog->arg, text);
 	}
 }
Index: uspace/lib/ui/src/rbutton.c
===================================================================
--- uspace/lib/ui/src/rbutton.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/rbutton.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -278,10 +278,10 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = rbutton->group->res->font;
 	fmt.color = rbutton->group->res->wnd_text_color;
 	fmt.halign = gfx_halign_left;
 	fmt.valign = gfx_valign_center;
 
-	rc = gfx_puttext(rbutton->group->res->font, &pos, &fmt,
-	    rbutton->caption);
+	rc = gfx_puttext(&pos, &fmt, rbutton->caption);
 	if (rc != EOK)
 		goto error;
@@ -316,4 +316,5 @@
 
 	gfx_text_fmt_init(&fmt);
+	fmt.font = rbutton->group->res->font;
 	fmt.color = depressed ? rbutton->group->res->entry_act_bg_color :
 	    rbutton->group->res->wnd_text_color;
@@ -321,6 +322,6 @@
 	fmt.valign = gfx_valign_top;
 
-	rc = gfx_puttext(rbutton->group->res->font, &pos, &fmt,
-	    rbutton->group->selected == rbutton ? "(\u2022)" : "( )");
+	rc = gfx_puttext(&pos, &fmt, rbutton->group->selected == rbutton ?
+	    "(\u2022)" : "( )");
 	if (rc != EOK)
 		goto error;
@@ -332,6 +333,5 @@
 	fmt.color = rbutton->group->res->wnd_text_color;
 
-	rc = gfx_puttext(rbutton->group->res->font, &pos, &fmt,
-	    rbutton->caption);
+	rc = gfx_puttext(&pos, &fmt, rbutton->caption);
 	if (rc != EOK)
 		goto error;
@@ -490,4 +490,6 @@
 		}
 		break;
+	case POS_DCLICK:
+		break;
 	}
 
Index: uspace/lib/ui/src/resource.c
===================================================================
--- uspace/lib/ui/src/resource.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/resource.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -62,4 +62,5 @@
 	gfx_color_t *btn_frame_color = NULL;
 	gfx_color_t *btn_face_color = NULL;
+	gfx_color_t *btn_face_lit_color = NULL;
 	gfx_color_t *btn_text_color = NULL;
 	gfx_color_t *btn_highlight_color = NULL;
@@ -67,5 +68,8 @@
 	gfx_color_t *wnd_face_color = NULL;
 	gfx_color_t *wnd_text_color = NULL;
+	gfx_color_t *wnd_dis_text_color = NULL;
+	gfx_color_t *wnd_text_hgl_color = NULL;
 	gfx_color_t *wnd_sel_text_color = NULL;
+	gfx_color_t *wnd_sel_text_hgl_color = NULL;
 	gfx_color_t *wnd_sel_text_bg_color = NULL;
 	gfx_color_t *wnd_frame_hi_color = NULL;
@@ -82,4 +86,6 @@
 	gfx_color_t *entry_sel_text_fg_color = NULL;
 	gfx_color_t *entry_sel_text_bg_color = NULL;
+	gfx_color_t *sbar_trough_color = NULL;
+	gfx_color_t *sbar_act_trough_color = NULL;
 	errno_t rc;
 
@@ -110,4 +116,8 @@
 		goto error;
 
+	rc = gfx_color_new_rgb_i16(0xe8e8, 0xe8e8, 0xe8e8, &btn_face_lit_color);
+	if (rc != EOK)
+		goto error;
+
 	rc = gfx_color_new_rgb_i16(0, 0, 0, &btn_text_color);
 	if (rc != EOK)
@@ -131,5 +141,18 @@
 		goto error;
 
+	rc = gfx_color_new_rgb_i16(0x9696, 0x9696, 0x9696, &wnd_dis_text_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_rgb_i16(0, 0, 0, &wnd_text_hgl_color);
+	if (rc != EOK)
+		goto error;
+
 	rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff, &wnd_sel_text_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_rgb_i16(0xffff, 0xffff, 0xffff,
+	    &wnd_sel_text_hgl_color);
 	if (rc != EOK)
 		goto error;
@@ -194,4 +217,14 @@
 
 	rc = gfx_color_new_rgb_i16(0, 0, 0xffff, &entry_sel_text_bg_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_rgb_i16(0xe4e4, 0xe4e4, 0xe4e4,
+	    &sbar_trough_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_rgb_i16(0x5858, 0x5858, 0x5858,
+	    &sbar_act_trough_color);
 	if (rc != EOK)
 		goto error;
@@ -204,4 +237,5 @@
 	resource->btn_frame_color = btn_frame_color;
 	resource->btn_face_color = btn_face_color;
+	resource->btn_face_lit_color = btn_face_lit_color;
 	resource->btn_text_color = btn_text_color;
 	resource->btn_highlight_color = btn_highlight_color;
@@ -210,5 +244,8 @@
 	resource->wnd_face_color = wnd_face_color;
 	resource->wnd_text_color = wnd_text_color;
+	resource->wnd_dis_text_color = wnd_dis_text_color;
+	resource->wnd_text_hgl_color = wnd_text_hgl_color;
 	resource->wnd_sel_text_color = wnd_sel_text_color;
+	resource->wnd_sel_text_hgl_color = wnd_sel_text_hgl_color;
 	resource->wnd_sel_text_bg_color = wnd_sel_text_bg_color;
 	resource->wnd_frame_hi_color = wnd_frame_hi_color;
@@ -227,4 +264,7 @@
 	resource->entry_sel_text_fg_color = entry_sel_text_fg_color;
 	resource->entry_sel_text_bg_color = entry_sel_text_bg_color;
+
+	resource->sbar_trough_color = sbar_trough_color;
+	resource->sbar_act_trough_color = sbar_act_trough_color;
 
 	*rresource = resource;
@@ -235,4 +275,6 @@
 	if (btn_face_color != NULL)
 		gfx_color_delete(btn_face_color);
+	if (btn_face_lit_color != NULL)
+		gfx_color_delete(btn_face_lit_color);
 	if (btn_text_color != NULL)
 		gfx_color_delete(btn_text_color);
@@ -246,6 +288,12 @@
 	if (wnd_text_color != NULL)
 		gfx_color_delete(wnd_text_color);
+	if (wnd_dis_text_color != NULL)
+		gfx_color_delete(wnd_dis_text_color);
+	if (wnd_text_hgl_color != NULL)
+		gfx_color_delete(wnd_text_hgl_color);
 	if (wnd_sel_text_color != NULL)
 		gfx_color_delete(wnd_sel_text_color);
+	if (wnd_sel_text_hgl_color != NULL)
+		gfx_color_delete(wnd_sel_text_hgl_color);
 	if (wnd_sel_text_bg_color != NULL)
 		gfx_color_delete(wnd_sel_text_bg_color);
@@ -279,4 +327,9 @@
 		gfx_color_delete(entry_act_bg_color);
 
+	if (sbar_trough_color != NULL)
+		gfx_color_delete(sbar_trough_color);
+	if (sbar_act_trough_color != NULL)
+		gfx_color_delete(sbar_act_trough_color);
+
 	if (tface != NULL)
 		gfx_typeface_destroy(tface);
@@ -299,4 +352,5 @@
 	gfx_color_t *btn_frame_color = NULL;
 	gfx_color_t *btn_face_color = NULL;
+	gfx_color_t *btn_face_lit_color = NULL;
 	gfx_color_t *btn_text_color = NULL;
 	gfx_color_t *btn_highlight_color = NULL;
@@ -304,5 +358,8 @@
 	gfx_color_t *wnd_face_color = NULL;
 	gfx_color_t *wnd_text_color = NULL;
+	gfx_color_t *wnd_dis_text_color = NULL;
+	gfx_color_t *wnd_text_hgl_color = NULL;
 	gfx_color_t *wnd_sel_text_color = NULL;
+	gfx_color_t *wnd_sel_text_hgl_color = NULL;
 	gfx_color_t *wnd_sel_text_bg_color = NULL;
 	gfx_color_t *wnd_frame_hi_color = NULL;
@@ -319,4 +376,6 @@
 	gfx_color_t *entry_sel_text_bg_color = NULL;
 	gfx_color_t *entry_act_bg_color = NULL;
+	gfx_color_t *sbar_trough_color = NULL;
+	gfx_color_t *sbar_act_trough_color = NULL;
 	errno_t rc;
 
@@ -342,4 +401,8 @@
 		goto error;
 
+	rc = gfx_color_new_ega(0x30, &btn_face_lit_color);
+	if (rc != EOK)
+		goto error;
+
 	rc = gfx_color_new_ega(0x20, &btn_text_color);
 	if (rc != EOK)
@@ -362,8 +425,20 @@
 		goto error;
 
+	rc = gfx_color_new_ega(0x78, &wnd_dis_text_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_ega(0x74, &wnd_text_hgl_color);
+	if (rc != EOK)
+		goto error;
+
 	rc = gfx_color_new_ega(0x07, &wnd_sel_text_color);
 	if (rc != EOK)
 		goto error;
 
+	rc = gfx_color_new_ega(0x04, &wnd_sel_text_hgl_color);
+	if (rc != EOK)
+		goto error;
+
 	rc = gfx_color_new_ega(0x07, &wnd_sel_text_bg_color);
 	if (rc != EOK)
@@ -402,21 +477,29 @@
 		goto error;
 
-	rc = gfx_color_new_ega(0x1b, &entry_fg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x1b, &entry_bg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x20, &entry_sel_text_fg_color);
-	if (rc != EOK)
-		goto error;
-
-	rc = gfx_color_new_ega(0x20, &entry_sel_text_bg_color);
+	rc = gfx_color_new_ega(0x07, &entry_fg_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_ega(0x07, &entry_bg_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_ega(0x1e, &entry_sel_text_fg_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_ega(0x1e, &entry_sel_text_bg_color);
 	if (rc != EOK)
 		goto error;
 
 	rc = gfx_color_new_ega(0x37, &entry_act_bg_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_ega(0x07, &sbar_trough_color);
+	if (rc != EOK)
+		goto error;
+
+	rc = gfx_color_new_ega(0x07, &sbar_act_trough_color);
 	if (rc != EOK)
 		goto error;
@@ -429,4 +512,5 @@
 	resource->btn_frame_color = btn_frame_color;
 	resource->btn_face_color = btn_face_color;
+	resource->btn_face_lit_color = btn_face_lit_color;
 	resource->btn_text_color = btn_text_color;
 	resource->btn_highlight_color = btn_highlight_color;
@@ -435,5 +519,8 @@
 	resource->wnd_face_color = wnd_face_color;
 	resource->wnd_text_color = wnd_text_color;
+	resource->wnd_dis_text_color = wnd_dis_text_color;
+	resource->wnd_text_hgl_color = wnd_text_hgl_color;
 	resource->wnd_sel_text_color = wnd_sel_text_color;
+	resource->wnd_sel_text_hgl_color = wnd_sel_text_hgl_color;
 	resource->wnd_sel_text_bg_color = wnd_sel_text_bg_color;
 	resource->wnd_frame_hi_color = wnd_frame_hi_color;
@@ -452,4 +539,7 @@
 	resource->entry_sel_text_fg_color = entry_sel_text_fg_color;
 	resource->entry_sel_text_bg_color = entry_sel_text_bg_color;
+
+	resource->sbar_trough_color = sbar_trough_color;
+	resource->sbar_act_trough_color = sbar_act_trough_color;
 
 	*rresource = resource;
@@ -460,4 +550,6 @@
 	if (btn_face_color != NULL)
 		gfx_color_delete(btn_face_color);
+	if (btn_face_lit_color != NULL)
+		gfx_color_delete(btn_face_lit_color);
 	if (btn_text_color != NULL)
 		gfx_color_delete(btn_text_color);
@@ -471,6 +563,12 @@
 	if (wnd_text_color != NULL)
 		gfx_color_delete(wnd_text_color);
+	if (wnd_dis_text_color != NULL)
+		gfx_color_delete(wnd_dis_text_color);
+	if (wnd_text_hgl_color != NULL)
+		gfx_color_delete(wnd_text_hgl_color);
 	if (wnd_sel_text_color != NULL)
 		gfx_color_delete(wnd_sel_text_color);
+	if (wnd_sel_text_hgl_color != NULL)
+		gfx_color_delete(wnd_sel_text_hgl_color);
 	if (wnd_sel_text_bg_color != NULL)
 		gfx_color_delete(wnd_sel_text_bg_color);
@@ -503,4 +601,8 @@
 	if (entry_sel_text_bg_color != NULL)
 		gfx_color_delete(entry_sel_text_bg_color);
+	if (sbar_trough_color != NULL)
+		gfx_color_delete(sbar_trough_color);
+	if (sbar_act_trough_color != NULL)
+		gfx_color_delete(sbar_act_trough_color);
 
 	if (tface != NULL)
@@ -537,4 +639,5 @@
 	gfx_color_delete(resource->btn_frame_color);
 	gfx_color_delete(resource->btn_face_color);
+	gfx_color_delete(resource->btn_face_lit_color);
 	gfx_color_delete(resource->btn_text_color);
 	gfx_color_delete(resource->btn_highlight_color);
@@ -543,4 +646,5 @@
 	gfx_color_delete(resource->wnd_face_color);
 	gfx_color_delete(resource->wnd_text_color);
+	gfx_color_delete(resource->wnd_dis_text_color);
 	gfx_color_delete(resource->wnd_sel_text_color);
 	gfx_color_delete(resource->wnd_sel_text_bg_color);
@@ -561,4 +665,7 @@
 	gfx_color_delete(resource->entry_sel_text_bg_color);
 
+	gfx_color_delete(resource->sbar_trough_color);
+	gfx_color_delete(resource->sbar_act_trough_color);
+
 	gfx_font_close(resource->font);
 	gfx_typeface_destroy(resource->tface);
@@ -604,4 +711,34 @@
 }
 
+/** Determine if resource is textmode.
+ *
+ * @param resource UI resource
+ * @return @c true iff resource is textmode
+ */
+bool ui_resource_is_textmode(ui_resource_t *resource)
+{
+	return resource->textmode;
+}
+
+/** Get the UI window face color.
+ *
+ * @param resource UI resource
+ * @return UI window face color
+ */
+gfx_color_t *ui_resource_get_wnd_face_color(ui_resource_t *resource)
+{
+	return resource->wnd_face_color;
+}
+
+/** Get the UI window text color.
+ *
+ * @param resource UI resource
+ * @return UI window text color
+ */
+gfx_color_t *ui_resource_get_wnd_text_color(ui_resource_t *resource)
+{
+	return resource->wnd_text_color;
+}
+
 /** @}
  */
